<?php

namespace Drupal\bazaarvoice_productfeed;


use BazaarvoiceProductFeed\Elements\FeedElementInterface;

class ProductFeed extends \BazaarvoiceProductFeed\ProductFeed {

  /*
   * Override parent method for saving a file.
   */
  public function saveFeed(FeedElementInterface $feed, $directory, $filename) {
    $saved = FALSE;
    // Get XML string of feed.
    if ($feed_xml = $this->printFeed($feed)) {
      // gzip file.
      if ($xml_file = gzencode($feed_xml)) {
        // Build Drupal URI path.
        $file_uri = file_default_scheme() . '://' . $directory . '/' . $filename . '.xml.gz';
        $file_directory = file_stream_wrapper_uri_normalize(file_default_scheme() . '://' . $directory);

        // Prepare file directory.
        if (file_prepare_directory($file_directory, FILE_CREATE_DIRECTORY)) {

          $file_path = file_stream_wrapper_uri_normalize($file_uri);
          // Save the file as unmangaged.
          if ($unmanaged_file = file_unmanaged_save_data($xml_file, $file_path, FILE_EXISTS_REPLACE)) {
            // Return full file location?
            $saved = file_create_url($unmanaged_file);
          }
        }
        else {
          // @TODO: return error, unable to create directory.
        }
      }
    }
    return $saved;
  }
}